﻿try {
    $private:a = $host.UI.RawUI
    $private:a.WindowTitle = "Тестирование знаний"
    $b = $a.BufferSize
    $b.Width = 120
    $b.Height = 25
    $a.BufferSize = $b
    $b = $a.WindowSize
    $b.Width = 120
    $b.Height = 25
    $a.WindowSize = $b
} finally {
    Remove-Variable a,b -ErrorAction SilentlyContinue
}

Clear-Host

$error.Clear | Out-Null
Write-Host  
Write-Host 'Original and comments: http://vam.in.ua/index.php/it/25-ms-powershell/165-powershell-learning-english.html' -ForegroundColor DarkCyan
Write-Host 'Feedback: http://vam.in.ua/index.php/contacts/2-admins/1-aleksey.html' -ForegroundColor DarkCyan
Write-Host  
Write-Host  

Function Private:Remove-Spaces ([string]$String) {
    while ($String.Substring(0,1) -eq ' ') {
        $String = $String.Substring(1,$String.Length - 1)
    }
    while ($String.Substring(($String.Length - 1),1) -eq ' ') {
        $String = $String.Substring(0, $String.Length - 1)
    }
    Return $String
}

Function Private:Get-Rank ([int32]$Percent) {
    [string]$Private:rank = 'Звание не определено!'
    if ($Percent -le 20) {$rank = 'Ни бе, ни ме, ни кукареку'}
    if (($Percent -gt 20) -and ($Percent -le 50)) {$rank = 'Простак'}
    if (($Percent -gt 50) -and ($Percent -le 80)) {$rank = 'Просветленный'}
    if (($Percent -gt 80) -and ($Percent -lt 95)) {$rank = 'Знаток'}
    if (($Percent -ge 95) -and ($Percent -le 99)) {$rank = 'Гуру'}
    if ($Percent -ge 100) {$rank = 'Гений'}
    Return $rank
}

[void]::($words = Get-Content .\base.txt -ErrorAction Stop)

$script:array = New-Object 'object[,]' $words.Count,2

$script:totalWords = 0
foreach ($word in $words) {
    if ($word.Length -gt 0) {
        try {
            [string]$private:eng = [regex]::Match($word,'.*(?=\t)')
            if ($eng.Length -gt 0) {
                $eng = Remove-Spaces -String $eng
                $array[$totalWords,1] = [regex]::Match($word,'(?<=\t).*')
                $array[$totalWords,0] = $eng
                $totalWords += 1
            }
            $eng = ''
        } finally {}
    }
}

Write-Host "Всего вопросов:   " $totalWords -ForegroundColor Cyan
Write-Host 
Write-Host 

[System.Collections.ArrayList]$numbArray = @(1..$totalWords)

$private:right = 0
$private:secondTry = 0
$private:mistakes = 0
$private:currentQ = 0

while ($numbArray.Count -gt 0) {
    
    $private:rndm = Get-Random -Minimum 0 -Maximum ($numbArray.Count)

    $private:item = $numbArray[$rndm]

    $numbArray.RemoveAt($rndm)

    $private:answer = Read-Host $array[($item - 1),1]

    if ($answer -ieq $array[($item - 1),0]) {
        $right += 1
        Write-Host 'Верно!' -ForegroundColor Green
    } else {
        Write-Host 'Не верно!' -ForegroundColor Yellow
        Write-Host  
        Write-Host 'Попробуем с подсказками:' -ForegroundColor DarkGray

        $private:variantsNum = 1
        [string]$private:variants = ''
        $private:rndm3 = Get-Random -Minimum 1 -Maximum 8
        while ($variantsNum -lt 8) {

            if ($rndm3 -eq $variantsNum) {
                $variants += ('[' + ($array[($item - 1),0]) + ']     ')
            } else {
                $private:rndm2 = Get-Random -Minimum 0 -Maximum ($totalWords)
                if (($array[$rndm2,0]) -eq ($array[($item - 1),0])) {
                    $variantsNum -= 1
                } else {
                    $variants += ('[' + ($array[$rndm2,0]) + "]     ")
                }
            }

            $variantsNum += 1
        }

        Write-Host $variants -ForegroundColor White
        Write-Host  
        
        $answer = Read-Host $array[($item - 1),1]

        if ($answer -ieq $array[($item - 1),0]) {
            $secondTry += 1
            Write-Host 'Таки да' -ForegroundColor Green
        } else {
            $mistakes += 1
            Write-Host 'Неа, не верно!' -ForegroundColor Red

            Write-Host  
            Write-Host  
            Write-Host "Правильный ответ:" -ForegroundColor DarkGray
            Write-Host $array[($item - 1),1] ": `t" $array[($item - 1),0] -ForegroundColor White
        }

    }

    $currentQ += 1

    Write-Host  
    [int32]$Private:percent = (($right + $secondTry + $mistakes) * 100 / $totalWords)
    Write-Host  '-------=============------- [' $currentQ '/' $totalWords ']  ' $percent '%' -ForegroundColor DarkGray
    Write-Host  
    Write-Host  

}

Write-Host  
Write-Host  
Write-Host "Всего вопросов: `t" $totalWords -ForegroundColor DarkCyan
Write-Host  
Write-Host "Верных ответов: `t" $right -ForegroundColor DarkCyan
Write-Host "Со второй попытки: `t" $secondTry -ForegroundColor DarkCyan
Write-Host "Ошибок: `t`t" $mistakes -ForegroundColor DarkCyan
$percent = ($right * 100 / $totalWords)
Write-Host  
Write-Host  
Write-Host "Точное знание: `t`t" $percent "%" -ForegroundColor Cyan
Write-Host  
$percent = $percent + (($secondTry * 100 / $totalWords) / 2)
$Private:finalRank = Get-Rank -Percent $percent
Write-Host "Ваш титул: `t`t" $finalRank -ForegroundColor Magenta
Write-Host  

Remove-Variable words,answer,array,numbArray,rndm,rndm2,rndm3,variants,variantsNum,percent,totalWords,finalRank,currentQ -ErrorAction SilentlyContinue

Write-Host  
Write-Host  
Write-Host "Для выхода нажмите ""Ctrl + C"" или закройте окно" -ForegroundColor DarkCyan
Start-Sleep -Seconds 65535
# SIG # Begin signature block
# MIIQJAYJKoZIhvcNAQcCoIIQFTCCEBECAQExCzAJBgUrDgMCGgUAMGkGCisGAQQB
# gjcCAQSgWzBZMDQGCisGAQQBgjcCAR4wJgIDAQAABBAfzDtgWUsITrck0sYpfvNR
# AgEAAgEAAgEAAgEAAgEAMCEwCQYFKw4DAhoFAAQUY16ALJ0CuZykCUwvztWZlrbe
# HL+ggg2CMIIFqDCCBJCgAwIBAgIKYQjZkAADAAAADDANBgkqhkiG9w0BAQUFADBf
# MQswCQYDVQQGEwJVQTEPMA0GA1UEChMGS1AgR0lDMRAwDgYDVQQLEwdDaXR5bmV0
# MS0wKwYDVQQDEyRDaXR5bmV0IFJvb3QgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkw
# HhcNMTMxMTIxMTExMzUwWhcNMjMxMTIxMTEyMzUwWjBdMQswCQYDVQQGEwJVQTEP
# MA0GA1UEChMGS1AgR0lDMRwwGgYDVQQLExNJbmZvcm1hdGlvbiBTeXN0ZW1zMR8w
# HQYDVQQDExZDaXR5bmV0IElzc3VpbmcgU3ViQ0ExMIIBIjANBgkqhkiG9w0BAQEF
# AAOCAQ8AMIIBCgKCAQEAkHPx2yWEKDjZ+2RmoZY1WSTT3YRO2BQ2Er7x+Fxm0Ngx
# 1A5Kx/sJbQvShXSRIgsS2E9olzYPB6x+n1WLVadmuWvXP8+++YamSR8XbejYSHVK
# 1stGHyDyDh6FAsfhZFYF949rXfJhA+2bSCR8mTI9H6jg64fRPhOjoKy9SpchAbig
# rsPAPIx5yP2zhranbZ4UaK587nsk99qn5ctXiwEj5jtCgWk31Tmc8LAfMkQoEDfT
# ofeNfClP+YxJUg9PAfowSTcj+U4+6EjWxaheQvcVFMfo/eno4vw7YTABjZ4js6Ti
# a5WlR0/IkrCsQD3Y71eycyxQgE4msSGy2mzBRxZmdQIDAQABo4ICZjCCAmIwDwYD
# VR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQUuapKg2DsRrEg9vKdH/UtczfOn2AwCwYD
# VR0PBAQDAgGGMBAGCSsGAQQBgjcVAQQDAgEDMCMGCSsGAQQBgjcVAgQWBBQhslK7
# x8zJihEqQAfHom0FvX7P0zBTBgNVHSAETDBKMEgGBFUdIAAwQDA+BggrBgEFBQcC
# ARYyaHR0cDovL2Nhc2Vydi5jaXR5bmV0LmtoYXJrb3YudWEvcGtpL3BvbGljaWVz
# Lmh0bWwwGQYJKwYBBAGCNxQCBAweCgBTAHUAYgBDAEEwHwYDVR0jBBgwFoAUPhrb
# 3Kv3R3TH6DOlfCESUiKZrdEwgYUGA1UdHwR+MHwweqB4oHaGOWh0dHA6Ly9yZW1v
# dGUuY2l0eW5ldC5raGFya292LnVhL2NybC9DaXR5bmV0Um9vdENBKDIpLmNybIY5
# aHR0cDovL2Nhc2Vydi5jaXR5bmV0LmtoYXJrb3YudWEvcGtpL0NpdHluZXRSb290
# Q0EoMikuY3JsMIHSBggrBgEFBQcBAQSBxTCBwjAxBggrBgEFBQcwAYYlaHR0cDov
# L3JlbW90ZS5jaXR5bmV0LmtoYXJrb3YudWEvb2NzcDBGBggrBgEFBQcwAoY6aHR0
# cDovL3JlbW90ZS5jaXR5bmV0LmtoYXJrb3YudWEvY2VydC9DaXR5bmV0Um9vdENB
# KDMpLmNydDBFBggrBgEFBQcwAoY5aHR0cDovL2Nhc2Vydi5jaXR5bmV0LmtoYXJr
# b3YudWEvcGtpL0NpdHluZXRSb290Q0EoMykuY3J0MA0GCSqGSIb3DQEBBQUAA4IB
# AQAYFWUIsQ1nVmBQEToNb2fb6kZAWxoePFXgs10of0/BadI5vZjx1JvRxVyILAjE
# UDhgvyGfvz4r/EEKSsjVbo0KVAEUFQkg/JbaT2aRMuGalnavIbre+6dt3b/KO3gc
# sPmsrMbB1oenO1P36lG3jIFwGE52bEsCVweWZo5aFcvzHIvKXiYIMkWQozJxRHo+
# SSKWnZeHYuyCAKAAiFtGWpFly8m2UCQlhIltVNvOcu9KcI7anByfiOCN9BYZ/ZmS
# /Sa3EMUz8JMg7KcBxEc3jn6jOoerTMowow3voEZvVnClF5WxGK4ECVD5K1jl5f1h
# AjyEYZvjq4zY6B9TOvHVHX/ZMIIH0jCCBrqgAwIBAgIKU5qRqwADAADohjANBgkq
# hkiG9w0BAQUFADBdMQswCQYDVQQGEwJVQTEPMA0GA1UEChMGS1AgR0lDMRwwGgYD
# VQQLExNJbmZvcm1hdGlvbiBTeXN0ZW1zMR8wHQYDVQQDExZDaXR5bmV0IElzc3Vp
# bmcgU3ViQ0ExMB4XDTE1MDQwMzEyMjY1M1oXDTIwMDQwMzEyMzY1M1owgZsxEjAQ
# BgoJkiaJk/IsZAEZFgJ1YTEXMBUGCgmSJomT8ixkARkWB2toYXJrb3YxFzAVBgoJ
# kiaJk/IsZAEZFgdjaXR5bmV0MQ4wDAYDVQQLEwVOZXREUDEoMCYGA1UECxMfSW5m
# b3JtYXRpb24gU2VjdXJpdHkgRGVwYXJ0bWVudDEZMBcGA1UEAxMQQWxleGV5IEl2
# YW5rbyBEQTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAJ0SibsKjM+d
# Dt41UIthXo0mE4cY1Y0QV0qUQBWkM6Jugp9TrBUg+5gDB+QRF1S3g5DdK3uKFIlM
# qMW/loS8XXH87feYjJUJc31I+xFOHSLtRL1nA/CqvkHgJZt/kxD99xG/kS0Sc2hx
# C9HuQnAEl8MIBLT0bWUx3K5Fr7EC+NPZ6Vnx9eLDPGCrtiCf+7vwXuB927GkrNKP
# RkhTZfpSkmY1TrH9d3GYRXHsUtGPO32YOFHq39tqiUZ/1x1wefFhU7XQMuuwE668
# bQnR6aClxRnOQViBYdsjJXZVH0BER1edmZURnHWf6aXvynLjRlI4GWjHJvRDKqc1
# PKmk87z3C4ECAwEAAaOCBFMwggRPMD0GCSsGAQQBgjcVBwQwMC4GJisGAQQBgjcV
# CIK6/G6F8vsWhY2JNIXM7miB8oEPgUeu6BeG8Md/AgFkAgEFME8GA1UdJQRIMEYG
# CisGAQQBgjcKAwEGCisGAQQBgjcKAw0GCisGAQQBgjc9AQEGCisGAQQBgjcKAwwG
# CisGAQQBgjcKBQEGCCsGAQUFBwMDMA4GA1UdDwEB/wQEAwIGwDBhBgkrBgEEAYI3
# FQoEVDBSMAwGCisGAQQBgjcKAwEwDAYKKwYBBAGCNwoDDTAMBgorBgEEAYI3PQEB
# MAwGCisGAQQBgjcKAwwwDAYKKwYBBAGCNwoFATAKBggrBgEFBQcDAzAdBgNVHQ4E
# FgQUD9yKNfC6uveKefQZbXVsOH8dNbcwHwYDVR0jBBgwFoAUuapKg2DsRrEg9vKd
# H/UtczfOn2AwggEkBgNVHR8EggEbMIIBFzCCAROgggEPoIIBC4Y8aHR0cDovL3Jl
# bW90ZS5jaXR5bmV0LmtoYXJrb3YudWEvY3JsL0NpdHluZXRJc3N1aW5nU3ViQ0Eu
# Y3JshoHKbGRhcDovLy9DTj1DaXR5bmV0JTIwSXNzdWluZyUyMFN1YkNBMSxDTj1D
# QVNlcnYsQ049Q0RQLENOPVB1YmxpYyUyMEtleSUyMFNlcnZpY2VzLENOPVNlcnZp
# Y2VzLENOPUNvbmZpZ3VyYXRpb24sREM9Y2l0eW5ldCxEQz1raGFya292LERDPXVh
# P2NlcnRpZmljYXRlUmV2b2NhdGlvbkxpc3Q/YmFzZT9vYmplY3RDbGFzcz1jUkxE
# aXN0cmlidXRpb25Qb2ludDCCAagGCCsGAQUFBwEBBIIBmjCCAZYwMQYIKwYBBQUH
# MAGGJWh0dHA6Ly9yZW1vdGUuY2l0eW5ldC5raGFya292LnVhL29jc3AwTQYIKwYB
# BQUHMAKGQWh0dHA6Ly9yZW1vdGUuY2l0eW5ldC5raGFya292LnVhL2NlcnQvQ2l0
# eW5ldElzc3VpbmdTdWJDQTEoMykuY3J0MIHDBggrBgEFBQcwAoaBtmxkYXA6Ly8v
# Q049Q2l0eW5ldCUyMElzc3VpbmclMjBTdWJDQTEsQ049QUlBLENOPVB1YmxpYyUy
# MEtleSUyMFNlcnZpY2VzLENOPVNlcnZpY2VzLENOPUNvbmZpZ3VyYXRpb24sREM9
# Y2l0eW5ldCxEQz1raGFya292LERDPXVhP2NBQ2VydGlmaWNhdGU/YmFzZT9vYmpl
# Y3RDbGFzcz1jZXJ0aWZpY2F0aW9uQXV0aG9yaXR5MEwGCCsGAQUFBzAChkBodHRw
# Oi8vY2FzZXJ2LmNpdHluZXQua2hhcmtvdi51YS9wa2kvQ2l0eW5ldElzc3VpbmdT
# dWJDQTEoMykuY3J0MDYGA1UdEQQvMC2gKwYKKwYBBAGCNxQCA6AdDBtJdmFua29E
# QUBjaXR5bmV0LmtoYXJrb3YudWEwDQYJKoZIhvcNAQEFBQADggEBABk2+S2SBHqa
# kmosxIfjiN9Mw7VsX9SQRmHyarB+Etr7HbRiZdzOP1a8ehYiHAxrfrOqxvoU82YM
# g961rapjt6ngvXiAvFspiXPQA5JBIbz9Vo0F0zUIcPrnvmFf3vQZuHHzZudVkXuO
# v3Z4HgmwHmwBI/lXE8ClZgEG+0ZEPd0fgZg5uzrXZJetjwRu1onu9JO+Hif4KHst
# SRLCokFEF7cMguMKBf4gSk5B5UXoqhLFNKwaqgknF1HJglNS02+pMX0Uf+V2RuB4
# zVQZ18YB9G9PPL5/CGNyXohwLWdXEmqrzibKu1SYcFTwjORKN1WznpkttZ0GzgB/
# H7J9K7w0zPQxggIMMIICCAIBATBrMF0xCzAJBgNVBAYTAlVBMQ8wDQYDVQQKEwZL
# UCBHSUMxHDAaBgNVBAsTE0luZm9ybWF0aW9uIFN5c3RlbXMxHzAdBgNVBAMTFkNp
# dHluZXQgSXNzdWluZyBTdWJDQTECClOakasAAwAA6IYwCQYFKw4DAhoFAKB4MBgG
# CisGAQQBgjcCAQwxCjAIoAKAAKECgAAwGQYJKoZIhvcNAQkDMQwGCisGAQQBgjcC
# AQQwHAYKKwYBBAGCNwIBCzEOMAwGCisGAQQBgjcCARUwIwYJKoZIhvcNAQkEMRYE
# FM1DAz4jmkph4Ao6kVr4Wvnao/mOMA0GCSqGSIb3DQEBAQUABIIBAJuDv1DAHBxQ
# v7zaAk7b5kPFyNrSJfxWw1lQKxvUxWjIm2ydJByB6egDJY3hG4phgyiD4UZR7Rt5
# kZwzzzAgfwnWc+BRRyAOiUgKBOw+8183jzlO+4G+arLPO5PU4S3es8xL27rOQcZn
# dVqnHIqYLQPhjZhGHbiu+qTDK/FpvFX33c7bRtKY1OS81TRHeThsSl4g1JI+xp6o
# NhyF3ExvE7lLRWU5TbfN8pKccdsbIuDtkANaqjVEMbzstFx+OJ/kGFeshU/dGO2T
# 8B1fFMf1nh0i05l8R1H0nK4i0J6Z9xqlNp6sZEw4hB6B5G/W+UQQyiMJavaPmSPL
# 2l8bgGOhlhY=
# SIG # End signature block
